<template>
  <div>
    <div class="row">
      <div class="col-sm-12" @change.prevent="createCategory">
        <div class="row">
          <div class="form-group col-4">
            <input type="text"
                   class="form-control"
                   name="class_name"
                   placeholder="Добавить новый класс"
                   v-model="nameCategory"
            >
          </div>
        </div>
        <div class="row mb-3">
          <div class="form-group col-4 row">
            <div class="col-2" style="margin-top: -6px; font-weight: bold; font-size: 18px">Статус:</div>
            <div class="col">
              <switches v-model="statusCategory" color="green"></switches>
            </div>
          </div>
        </div>
      </div><!-- /.col -->
    </div><!-- /.row -->
    <div ref="container"></div>
    <div class="row justify-content-between">
      <div class="col">
        <a class="btn btn-primary" :href="path">Назад</a>
      </div>
      <div class="col text-right">
        <a class="btn btn-primary" href="#" @click="addComponent">Добавить модель класса</a>
      </div>
    </div>
  </div>
</template>

<script>
import Vue from 'vue'
import AddModelComponent from "./AddModelComponent";
import Switches from 'vue-switches';

export default {
  name: "CategoryComponent",
  components: {AddModelComponent, Switches},
  props: {
    path: String
  },
  data() {
    return {
      nameCategory: null,
      model: [],
      numberInOrder: 1,
      statusCategory: false,
    }
  },
  methods: {
    createCategory() {
      let data = new FormData();
      data.append('category_status', Number(this.statusCategory));
      data.append('category_name', this.nameCategory);
      axios.post('/api/admin/category', data)
          .then(res => {
            console.log(res.data)
          })
    },
    addComponent() {
      if (!this.nameCategory) return alert('Забыли задать название класса');
      var ComponentCategory = Vue.extend(AddModelComponent)
      var instance = new ComponentCategory({
        propsData: {
          numberInOrder: this.numberInOrder,
          nameCategory: this.nameCategory,
          statusCategory: this.statusCategory
        },
      })
      instance.$mount()
      instance.$on("response", e => this.model.push(e));
      this.$refs.container.appendChild(instance.$el)
      this.numberInOrder++
    }
  }
}
</script>

<style scoped>

</style>
//https://css-tricks.com/creating-vue-js-component-instances-programmatically/